#!/bin/bash

which python >& /dev/null
if [ $? -eq 0 ]; then
	PYTHON=python
fi
which python2 >& /dev/null
if [ $? -eq 0 ]; then
	PYTHON=python2
fi
which python3 >& /dev/null
if [ $? -eq 0 ]; then
	PYTHON=python3
fi
if [ x$PYTHON == x ]; then
	echo 'Can not find python command'
	exit 1
fi

module load `module avail |& grep AArch64 |& grep armpl | grep compiler | sort -r | head -1`

#cat data/bblas_data.csv data/bblas_data_hgemm.csv > data/bblas_data_armpl.csv

$PYTHON bblas.py data/bblas_data_armpl.csv

export CC=armclang

make clean

make lib && echo -e '\n\nIf you need to build samples or testing tools,\nedit Makefile in ./sample or ./bblas_test appropriately,\nthen, run "CC=armclang make sample_make" or "CC=armclang make test_make", respectively.\n'

