
#include "batched_blas_test_common.h"

// return random integer l_num <= xxx <= u_num
int random_int(int l_num, int u_num)
{
  return l_num + (lrand48() % (u_num - l_num + 1));
}

// CBLAS_LAYOUT : C or R
CBLAS_LAYOUT layout_(char l)
{
  if(l == 'r' || l == 'R')
    return CblasRowMajor;
  else
    return CblasColMajor;
}

CBLAS_LAYOUT r_layout_()
{
  double r_num = drand48();
  
  if(r_num > 0.5)
    return CblasRowMajor;
  else
    return CblasColMajor;
}

// CBLAS_TRANSPOSE : N or T or C
CBLAS_TRANSPOSE transpose_(char t)
{
  if(t == 't' || t == 'T')
    return CblasTrans;
  else if(t == 'c' || t == 'C')
    return CblasConjTrans;
  else  
    return CblasNoTrans;
}

CBLAS_TRANSPOSE r_transpose_()
{
  double r_num = drand48();
  
  if(r_num > 2.0 / 3.0)
    return CblasTrans;
  else if(r_num > 1.0 / 3.0)
    return CblasNoTrans;
  else
    return CblasConjTrans;
}

CBLAS_TRANSPOSE r_transpose_t_()
{
  double r_num = drand48();
  
  if(r_num > 0.5)
    return CblasTrans;
  else  
    return CblasNoTrans;
}

CBLAS_TRANSPOSE r_transpose_c_()
{
  double r_num = drand48();
  
  if(r_num > 0.5)
    return CblasConjTrans;
  else  
    return CblasNoTrans;
}

// CBLAS_UPLO : U or L
CBLAS_UPLO uplo_(char u)
{
  if(u == 'l' || u == 'L')
    return CblasLower;
  else  
    return CblasUpper;
}

CBLAS_UPLO r_uplo_()
{
  double r_num = drand48();
  
  if(r_num > 0.5)
    return CblasLower;
  else  
    return CblasUpper;
}

// U or N
CBLAS_DIAG diag_(char d)
{
  if(d == 'u' || d == 'U')
    return CblasUnit;
  else  
    return CblasNonUnit;
}

CBLAS_DIAG r_diag_()
{
  double r_num = drand48();
  
  if(r_num > 0.5)
    return CblasUnit;
  else  
    return CblasNonUnit;
}

// L or R
CBLAS_SIDE side_(char s)
{
  if(s == 'r' || s == 'R')
    return CblasRight;
  else  
    return CblasLeft;
}

CBLAS_SIDE r_side_()
{
  double r_num = drand48();
  
  if(r_num > 0.5)
    return CblasRight;
  else  
    return CblasLeft;
}

