#ifndef BATCHED_BLAS_TEST_COMMON_H
#define BATCHED_BLAS_TEST_COMMON_H

#include <stdlib.h>
#include "batched_blas.h"

// 0.0 <= xxx <= 1.0
#define VAL_RANGE (5.0e-1)
// 0.0 <= xxx <= 1.0
#define MAX_INC 5

#define MAX_2(a,b) ((a) > (b) ? (a) : (b))
#define MIN_2(a,b) ((a) < (b) ? (a) : (b))
#define SQR(a) ((a) * (a))

int random_int(int l_num, int u_num);

// get parameter from character
CBLAS_LAYOUT layout_(char l);
CBLAS_TRANSPOSE transpose_(char t);
CBLAS_UPLO uplo_(char u);
CBLAS_DIAG diag_(char d);
CBLAS_SIDE side_(char s);

// CBLAS_TRANSPOSE : N or T or C
CBLAS_LAYOUT r_layout_();
CBLAS_TRANSPOSE r_transpose_();
CBLAS_TRANSPOSE r_transpose_t_();
CBLAS_TRANSPOSE r_transpose_c_();
CBLAS_UPLO r_uplo_();
CBLAS_DIAG r_diag_();
CBLAS_SIDE r_side_();

#endif
